import React, { PropTypes } from 'react';
import PureRenderMixin from 'react-addons-pure-render-mixin';

import FoundationErrors from './FoundationErrors';

import { pgettext } from '../../utils/lang';


const FoundationFormFieldErrors = React.createClass({

    mixins: [PureRenderMixin],

    propTypes: {
        errors: PropTypes.object
    },

    getDefaultProps() {
        return {
            errors: {}
        };
    },

    render() {
        const errors = Object.keys(this.props.errors).map((key) => {
            return (
                <span key={ key }>{ pgettext('form field error field', key) } { '-' } { pgettext('action-form-errors', this.props.errors[key].join(', ')) }</span>
            );
        });

        return (
            <FoundationErrors
                errors={ errors } />
        );
    }

});

export default FoundationFormFieldErrors;
