import ContainerWrapper from '../ContainerWrapper';
import actionName from '../../utils/actionName';

import radioButtonGroupChange from './redux/radioButtonGroupChange';


export const changeType = actionName('CHANGE');

export default ({
    Component
} = {}) => {

    const mapDispatchToProps = (dispatch, props) => {
        const { customActionMetadata: custom, path, root } = props;
        const actionTypePrefix = props.actionTypePrefix || 'RADIO-BUTTON-GROUP';

        return {
            onChange: (value) => dispatch(radioButtonGroupChange({ custom, path, root, type: changeType(actionTypePrefix), value }))
        };
    };

    return ContainerWrapper({
        Component,
        mapDispatchToProps
    });

};
