import React from 'react';
import purebem from 'purebem';
import { mount } from 'enzyme';

import RadioButtonCustomOption from './RadioButtonCustomOption';


const TestRadioButtonCustomOption = RadioButtonCustomOption({
    block: purebem.of('test-radio-button-group'),
    displayName: 'TestRadioButtonCustomOption'
});

test('should change value when clicked and is unchecked', () => {
    const onChange = jest.fn();
    const option = mount(
        <TestRadioButtonCustomOption
            checked={ false }
            onChange={ onChange }
            value="test" />
    );

    option.simulate('click');

    expect(onChange).toHaveBeenCalledWith('test');
});

[
    { name: 'should not change value when clicked and is unchecked and disabled', data: { checked: false } },
    { name: 'should not change value when clicked and is checked and disabled', data: { checked: true } }
].forEach((fixture) => {
    test(fixture.name, () => {
        const onChange = jest.fn();
        const option = mount(
            <TestRadioButtonCustomOption
                checked={ fixture.data.checked }
                disabled={ true }
                onChange={ onChange }
                value="test" />
        );

        option.simulate('click');

        expect(onChange).not.toHaveBeenCalled();
    });
});
