import ContainerWrapper from '../ContainerWrapper';
import actionName from '../../utils/actionName';

import switchChange from './redux/switchChange';


export const changeType = actionName('CHANGE');

export default ({
    Component
} = {}) => {

    const mapDispatchToProps = (dispatch, props) => {
        const { customActionMetadata: custom, path, root } = props;
        const actionTypePrefix = props.actionTypePrefix || 'SWITCH';

        return {
            onChange: (value) => dispatch(switchChange({ custom, path, root, type: changeType(actionTypePrefix), value }))
        };
    };

    return ContainerWrapper({
        Component,
        mapDispatchToProps
    });

};
